; LCD (DATA)									
.equ LCD_DATA0_DDR			= DDRD
.equ LCD_DATA1_DDR			= DDRD
.equ LCD_DATA2_DDR			= DDRD
.equ LCD_DATA3_DDR			= DDRD
.equ LCD_DATA0_PORT			= PORTD
.equ LCD_DATA1_PORT			= PORTD
.equ LCD_DATA2_PORT			= PORTD
.equ LCD_DATA3_PORT			= PORTD
.equ LCD_DATA0				= 0
.equ LCD_DATA1				= 1
.equ LCD_DATA2				= 2
.equ LCD_DATA3				= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR				= DDRD
.equ LCD_RS_PORT			= PORTD
.equ LCD_RS					= 4
; LCD_ENABLE									
.equ LCD_EN_DDR				= DDRD
.equ LCD_EN_PORT			= PORTD
.equ LCD_EN					= 5
; ##############################################################################
; ##############################################################################
; ##############################################################################
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_EN_DDR),(LCD_EN)
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_EN_PORT),(LCD_EN)
	cbi (LCD_RS_PORT),(LCD_RS)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS) 			; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	call LCD_ENABLE					; 1	
	call LCD_ENABLE					; 2	
	call LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen
	call LCD_COMMAND
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	call LCD_COMMAND
;   ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken on
;   ldi temp, 0b00001110        ; DISPLAY ein / CURSOR blinken off
    ldi temp, 0b00001100        ; DISPLAY ein / CURSOR blinken off
	call LCD_COMMAND
    ldi temp, 0b00000110        ; Cursor Auto-Increment
 	call LCD_COMMAND
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;erzeugt den Enable-Puls												  		
LCD_ENABLE:
 	call wait_5us            		  	; kurze PAUSE		
	sbi LCD_EN_PORT, LCD_EN    		   	; Enable high		
 	call wait_100us            		  	; kurze PAUSE		
	cbi LCD_EN_PORT, LCD_EN     	  	; Enable low		
ret                          
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sendet ein Datenbyte an das LCD										  		
LCD_DATA_TEMP:
	sbi (LCD_RS_PORT),(LCD_RS)			; RS=H 	
	rjmp LCD_DATA_RUN
LCD_DATA_RS:
    cbi (LCD_RS_PORT),(LCD_RS) 			; RS=L	
;-------------------------------------------------------------------------------
LCD_DATA_RUN:
	SBRS temp,4							; SPRUNG, wenn BIT set		
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,5		
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,6		
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,7	
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	call LCD_ENABLE        				; Enable	
;-------------------------------------------------------------------------------
	SBRS temp,0							; SPRUNG, wenn BIT set		
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,1		
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,2		
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,3		
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear	
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	call LCD_ENABLE        				; Enable	
ret				                       
; ##############################################################################
; ##############################################################################
; ##############################################################################
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  		
;																		  		
; INPUT: temp															  		
;																		  		
LCD_COMMAND:                            
	call LCD_DATA_RS
	jmp wait_5ms						; Pause (wichtig)				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "6"																		
LCD_ZAHL1_TEMP1:
	cpi temp1,9+1	; berlauf	
	brlo LCD_ZAHL1_TEMP1_RUN
	rjmp LCD_MINUS
;-------------------------------------------------------------------------------
LCD_ZAHL1_TEMP1_RUN:
	clr temp2
	clr temp3
	clr temp4
 	call FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	rjmp LCD_DATA_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B: "06"																		
LCD_ZAHL2_TEMP1:
	cpi temp1,99+1	; berlauf	
	brlo LCD_ZAHL2_TEMP1_RUN
	call LCD_MINUS
	rjmp LCD_MINUS
;-------------------------------------------------------------------------------
LCD_ZAHL2_TEMP1_RUN:
	clr temp2
	clr temp3
	clr temp4
 	call FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp2			; 2.
	call LCD_DATA_TEMP	
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	rjmp LCD_DATA_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZAHL_TEMP1:
	clr temp2
LCD_ZAHL_TEMP1_2:
	clr temp3
LCD_ZAHL_TEMP1_2_3:
	clr temp4
LCD_ZAHL_TEMP1_2_3_4:
	rjmp LCD_ZAHL_FORMATIERT
; ##############################################################################
LCD_ZAHL_TEMP1_2_3_4_FIX:
 	call FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	rjmp LCD_ZIFFERN_10
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ZAHL_FORMATIERT:
 	call FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	cpi temp,'0'
	brne LCD_ZIFFERN_10
	cpi temp9,'0'
	brne LCD_ZIFFERN_9
	cpi temp8,'0'
	brne LCD_ZIFFERN_8
	cpi temp7,'0'
	brne LCD_ZIFFERN_7
	cpi temp6,'0'
	brne LCD_ZIFFERN_6
	cpi temp5,'0'
	brne LCD_ZIFFERN_5
	cpi temp4,'0'
	brne LCD_ZIFFERN_4
	cpi temp3,'0'
	brne LCD_ZIFFERN_3
	cpi temp2,'0'
	brne LCD_ZIFFERN_2
	rjmp LCD_ZIFFERN_1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...TEMP9 (temp)												
LCD_ZIFFERN_10:
	; temp !
	call LCD_DATA_TEMP		;10.
	call LCD_PUNKT				;'.'
LCD_ZIFFERN_9:
	mov temp, temp9			; 9.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_8:
	mov temp, temp8			; 8.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_7:
	mov temp, temp7			; 7.
	call LCD_DATA_TEMP	
	call LCD_PUNKT				;'.'
LCD_ZIFFERN_6:
	mov temp, temp6			; 6.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_5:
	mov temp, temp5			; 5.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_4:
	mov temp, temp4			; 4.
	call LCD_DATA_TEMP
	call LCD_PUNKT				;'.'
LCD_ZIFFERN_3:
	mov temp, temp3			; 3.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_2:
	mov temp, temp2			; 2.
	call LCD_DATA_TEMP	
LCD_ZIFFERN_1:
	mov temp, temp1			; 1.ZIFFER (1-er Stelle)	
	call LCD_DATA_TEMP
	jmp LCD_SPACE			;' '
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																	
; OUT: (z.B."FF") 																
LCD_HEX_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp						; NIBBLES tausch	
	call LCD_HEX8_UMWANDLUNG	; INP/OUT: temp		
	call LCD_DATA_TEMP					; ANZEIGE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	call LCD_HEX8_UMWANDLUNG	; INP/OUT: temp		
	call LCD_DATA_TEMP					; ANZEIGE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
LCD_HEX8_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh LCD_HEX8_UMWANDLUNG_A_F
LCD_HEX8_UMWANDLUNG_0_9:
	subi temp,-48
	ret
LCD_HEX8_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1+2																	
; OUT: (z.B."FFFF") 															
LCD_HEX16_TEMP1_2:
	push temp1
	mov temp1,temp2
	call LCD_HEX_TEMP1
	pop temp1
	call LCD_HEX_TEMP1
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; STAND: 09.12.2011															
;																			
;	Value: 0...	9.999.999.999												
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			temp	(1.000.000.000-er Stelle)								
; 																			
FUNKTION_HEX_ASC_32:
;---------------------------------------------------------------------------
	clr temp			
FUNKTION_HEX_ASC_109:	; 1.100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_109
	subi temp, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNKTION_HEX_ASC_108:	; 100.000.000
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_108
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNKTION_HEX_ASC_107:	; 10.000.000
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_107
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNKTION_HEX_ASC_106:	; 1.000.000
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_106
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_105:	; 100.000	
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_105
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNKTION_HEX_ASC_104:	; 10.000	
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_104
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNKTION_HEX_ASC_103:	; 1.000		
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_103
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNKTION_HEX_ASC_102:	; 100		
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_102
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNKTION_HEX_ASC_101:	; 10		
	inc temp2
	subi temp1, low  (10)
	brcc FUNKTION_HEX_ASC_101
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNKTION_HEX_ASC_100:	; 1			
	subi temp1, -48		; HEX->ASC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																	
; OUT: (z.B."00000000") 														
LCD_BIN8_TEMP1:
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	LSL temp1
	rcall LCD_BIN8_TEMP1_10
	ret
LCD_BIN8_TEMP1_10:
	push temp1
	brcc LCD_BIN8_TEMP1_0
	rcall LCD_1
	pop temp1
	ret
LCD_BIN8_TEMP1_0:
	rcall LCD_0
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Text aus Tabelle																
LCD_ANZEIGE_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ANZEIGE_TEXT_w
	ret
ANZEIGE_TEXT_w:
	call LCD_DATA_TEMP			; Anzeige
	rjmp LCD_ANZEIGE_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Display lschen														  		
LCD_CLEAR:
   	ldi temp, 0b00000001
    call lcd_command
	jmp LCD_ZEILE1
;-------------------------------------------------------------------------------
; KURSOR GO-HOME														  		
LCD_ZEILE1:
 	ldi temp, 0b00000010
	jmp LCD_COMMAND
;-------------------------------------------------------------------------------
; KURSOR Sprung in ZEILE2												  		
LCD_ZEILE2:
 	ldi temp, 0b11000000 
	jmp LCD_COMMAND
;-------------------------------------------------------------------------------
; KURSOR Sprung in ZEILE3														
LCD_ZEILE3:
	ldi temp, 0b10010000 	; LCD 4x16	
; 	ldi temp, 0b10010100  	; LCD 4x20
	jmp LCD_COMMAND
;-------------------------------------------------------------------------------
; KURSOR Sprung in ZEILE4												  		
LCD_ZEILE4:
	ldi temp, 0b11010000 	; LCD 4x16	
;	ldi temp, 0b11010100	; LCD 4x20
	jmp LCD_COMMAND
;-------------------------------------------------------------------------------
LCD_SPACE8:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE7:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE6:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP
LCD_SPACE5:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE4:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE3:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE2:
	ldi temp, ' '			; SPACE
	call LCD_DATA_TEMP	
LCD_SPACE:
	ldi temp, ' '			; SPACE
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_KOMMA:
	ldi temp, ','			; Komma
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_PUNKT:
	ldi temp, '.'			; PUNKT
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_PUNKT3:
	ldi temp, '.'			;3 PUNKT
	call LCD_DATA_TEMP	
	call LCD_DATA_TEMP	
	jmp  LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_DOPPEL_PUNKT:
	ldi temp, ':'			; DOPPELPUNKT
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_DOPPEL_PUNKT_SPACE:
	ldi temp, ':'			; ': '	
	call LCD_DATA_TEMP
	jmp LCD_SPACE
LCD_PLUS:
	ldi temp, '+'			; '-'	
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
LCD_MINUS4:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS3:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS2:
	ldi temp, '-'			; '-'	
	call LCD_DATA_TEMP
LCD_MINUS:
	ldi temp, '-'			; '-'	
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_GRD:
	ldi temp,223
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_STERN:
	ldi temp,'*'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_FRAGEZEICHEN:
	ldi temp,'?'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_AUSRUFEZEICHEN:
	ldi temp,'!'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_PROZENT:
	ldi temp,'%'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_SCHRAEGSTRICH:
	ldi temp,'/'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_GAENSEFUESSCHEN:
	ldi temp,'"'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_ISTGLEICH:
	ldi temp,'='
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------
LCD_0:
	ldi temp, '0'
	jmp LCD_DATA_TEMP	
LCD_1:
	ldi temp, '1'
	jmp LCD_DATA_TEMP	
LCD_2:
	ldi temp, '2'
	jmp LCD_DATA_TEMP	
LCD_3:
	ldi temp, '3'
	jmp LCD_DATA_TEMP	
LCD_4:
	ldi temp, '4'
	jmp LCD_DATA_TEMP	
LCD_5:
	ldi temp, '5'
	jmp LCD_DATA_TEMP	
LCD_6:
	ldi temp, '6'
	jmp LCD_DATA_TEMP	
LCD_7:
	ldi temp, '7'
	jmp LCD_DATA_TEMP	
LCD_8:
	ldi temp, '8'
	jmp LCD_DATA_TEMP	
LCD_9:
	ldi temp, '9'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_A:
	ldi temp, 'A'
	jmp LCD_DATA_TEMP	
LCD_B:
	ldi temp, 'B'
	jmp LCD_DATA_TEMP	
LCD_C:
	ldi temp, 'C'
	jmp LCD_DATA_TEMP	
LCD_D:
	ldi temp, 'D'
	jmp LCD_DATA_TEMP	
LCD_E:
	ldi temp, 'E'
	jmp LCD_DATA_TEMP	
LCD_F:
	ldi temp, 'F'
	jmp LCD_DATA_TEMP	
LCD_G:
	ldi temp, 'G'
	jmp LCD_DATA_TEMP	
LCD_H:
	ldi temp, 'H'
	jmp LCD_DATA_TEMP	
LCD_I:
	ldi temp, 'I'
	jmp LCD_DATA_TEMP	
LCD_J:
	ldi temp, 'J'
	jmp LCD_DATA_TEMP	
LCD_K:
	ldi temp, 'K'
	jmp LCD_DATA_TEMP	
LCD_L:
	ldi temp, 'L'
	jmp LCD_DATA_TEMP	
LCD_M:
	ldi temp, 'M'
	jmp LCD_DATA_TEMP	
LCD_N:
	ldi temp, 'N'
	jmp LCD_DATA_TEMP	
LCD_O:
	ldi temp, 'O'
	jmp LCD_DATA_TEMP	
LCD_P:
	ldi temp, 'P'
	jmp LCD_DATA_TEMP	
LCD_Q:
	ldi temp, 'Q'
	jmp LCD_DATA_TEMP	
LCD_R:
	ldi temp, 'R'
	jmp LCD_DATA_TEMP	
LCD_S:
	ldi temp, 'S'
	jmp LCD_DATA_TEMP	
LCD_T:
	ldi temp, 'T'
	jmp LCD_DATA_TEMP	
LCD_U:
	ldi temp, 'U'
	jmp LCD_DATA_TEMP	
LCD_V:
	ldi temp, 'V'
	jmp LCD_DATA_TEMP	
LCD_W:
	ldi temp, 'W'
	jmp LCD_DATA_TEMP	
LCD_X:
	ldi temp, 'X'
	jmp LCD_DATA_TEMP	
LCD_Y:
	ldi temp, 'Y'
	jmp LCD_DATA_TEMP	
LCD_Z:
	ldi temp, 'Z'
	jmp LCD_DATA_TEMP	
;-------------------------------------------------------------------------------
LCD_A_:
	ldi temp, 'a'
	jmp LCD_DATA_TEMP	
LCD_B_:
	ldi temp, 'b'
	jmp LCD_DATA_TEMP	
LCD_C_:
	ldi temp, 'c'
	jmp LCD_DATA_TEMP	
LCD_D_:
	ldi temp, 'd'
	jmp LCD_DATA_TEMP	
LCD_E_:
	ldi temp, 'e'
	jmp LCD_DATA_TEMP	
LCD_F_:
	ldi temp, 'f'
	jmp LCD_DATA_TEMP	
LCD_G_:
	ldi temp, 'g'
	jmp LCD_DATA_TEMP	
LCD_H_:
	ldi temp, 'h'
	jmp LCD_DATA_TEMP	
LCD_I_:
	ldi temp, 'i'
	jmp LCD_DATA_TEMP	
LCD_J_:
	ldi temp, 'j'
	jmp LCD_DATA_TEMP	
LCD_K_:
	ldi temp, 'k'
	jmp LCD_DATA_TEMP	
LCD_L_:
	ldi temp, 'l'
	jmp LCD_DATA_TEMP	
LCD_M_:
	ldi temp, 'm'
	jmp LCD_DATA_TEMP	
LCD_N_:
	ldi temp, 'n'
	jmp LCD_DATA_TEMP	
LCD_O_:
	ldi temp, 'o'
	jmp LCD_DATA_TEMP	
LCD_P_:
	ldi temp, 'p'
	jmp LCD_DATA_TEMP	
LCD_Q_:
	ldi temp, 'q'
	jmp LCD_DATA_TEMP	
LCD_R_:
	ldi temp, 'r'
	jmp LCD_DATA_TEMP	
LCD_S_:
	ldi temp, 's'
	jmp LCD_DATA_TEMP	
LCD_T_:
	ldi temp, 't'
	jmp LCD_DATA_TEMP	
LCD_U_:
	ldi temp, 'u'
	jmp LCD_DATA_TEMP	
LCD_V_:
	ldi temp, 'v'
	jmp LCD_DATA_TEMP	
LCD_W_:
	ldi temp, 'w'
	jmp LCD_DATA_TEMP	
LCD_X_:
	ldi temp, 'x'
	jmp LCD_DATA_TEMP	
LCD_Y_:
	ldi temp, 'y'
	jmp LCD_DATA_TEMP	
LCD_Z_:
	ldi temp, 'z'
	jmp LCD_DATA_TEMP
;-------------------------------------------------------------------------------































