; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: SRAM(adr_DATA)															
FLOPPY_SPUR_READ:
	CLI										; INTERRUPTS sperren !!!	
	call FLOPPY_MOTOR_ON					; Motor on			
;-------------------------------------------------------------------------------
; Impulse am DATA-PIN ?															
	clr XL
	clr XH
FLOPPY_SPUR_s1:
	sbiw XL,1
	tst XL
	brne FLOPPY_SPUR_s1_	
	tst XH
	brne FLOPPY_SPUR_s1_	
	rjmp FLOPPY_SPUR_READ_ERROR
FLOPPY_SPUR_s1_:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN HIGH		
	rjmp FLOPPY_SPUR_s1
;-------------------------------------------------------------------------------
; Impulse am DATA-PIN ?															
	clr XL
	clr XH
FLOPPY_SPUR_s2:
	sbiw XL,1
	tst XL
	brne FLOPPY_SPUR_s2_	
	tst XH
	brne FLOPPY_SPUR_s2_	
	rjmp FLOPPY_SPUR_READ_ERROR
FLOPPY_SPUR_s2_:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN LOW	
	rjmp FLOPPY_SPUR_s2
;-------------------------------------------------------------------------------
	rcall FLOPPY_WAIT_INDEX_HIGH			; Index				
	rcall FLOPPY_WAIT_INDEX_LOW				; Index				
	ldi YL,LOW (adr_DATA)					; DATA					
	ldi YH,HIGH(adr_DATA)
	ldi temp9,18							; physische Sektoren read (1-2-3...18)
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus			
;-------------------------------------------------------------------------------
FLOPPY_SPUR_s:
	push temp9
	ldi ZL, low(TABELLE_MFM_ID_SEKTOR*2)	; Tabelle				
	ldi ZH,high(TABELLE_MFM_ID_SEKTOR*2)
	ldi XL, low(6)							; Anzahl Data Bytes		
	ldi XH,high(6)
	mov temp4,NULL							; Merkbit=0				
	rcall MFM
;-------------------------------------------------------------------------------
	ldi ZL,  low(TABELLE_MFM_ID_DATA*2)		; Tabelle				
	ldi ZH, high(TABELLE_MFM_ID_DATA*2)
	ldi XL, low(512+2)						; Anzahl Data Bytes		
	ldi XH,high(512+2)
	mov temp4,EINS							; Merkbit=1				
	rcall MFM
	pop temp9
;-------------------------------------------------------------------------------
	dec temp9
	brne FLOPPY_SPUR_s
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN an				
	SEI										; Interrupts enable		
;-------------------------------------------------------------------------------
	call MFM_CHECK
	call MFM_ANZEIGE	
	call RS232_TX_SRAM  					;(fr Testzwecke)		
	ret
;-------------------------------------------------------------------------------
FLOPPY_SPUR_READ_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an		
	call LCD_CLEAR
	call TEXT_DISK
	call TEXT_ERROR

	call WAIT_1s
	call WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MFM und direkte Decodierung													
;																				
; X = Anzahl Data Bytes															
; Y = Zeiger DATA																
; Z = Tabelle																	
;																				
; temp1 = Zeitstempel															
; temp2 = Zellenwert (aus Zeitstempel)											
; temp4 = Merkbit																
; temp8	= DataByte																
; temp9	= Byte-Counter															
; 																				
MFM:
.equ ZELLE1=54								; bis 54 C Takte = Zelle1
.equ ZELLE2=75								; bis 75 C Takte = Zelle2
	mov R0,ZL								; Tabelle sichern	
	mov R1,ZH
;-------------------------------------------------------------------------------
MFM_s:										; Schleife			
	in temp1,TCNT0							; Zeitstempel		
	OUT TCNT0,NULL							; Null				
;-------------------------------------------------------------------------------
MFM_s1:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN HIGH		
	rjmp MFM_s1
;-------------------------------------------------------------------------------
; Umrechnung von Zeiten- in Zellenwerte											
	ldi temp2,1								; Zellenwert-1	
	cpi temp1,(ZELLE1)
	brlo MFM_w
	ldi temp2,2								; Zellenwert-2	
	cpi temp1,(ZELLE2)
	brlo MFM_w
	ldi temp2,3								; Zellenwert-3	
MFM_w:
;-------------------------------------------------------------------------------
; Vergleich Zellenwert mit Tabelle (Muster finden)								
	LPM temp, Z+ 		  					; Tabellenwert laden	
	cp temp,temp2							; Vergleich 			
	breq MFM_w1						 		; Treffer				
	mov ZL,R0								; Z auf Tabelle			
	mov ZH,R1
	rjmp MFM_w2
;-------------------------------------------------------------------------------
MFM_w1:
	LPM temp, Z 		  					; nchsten Tabellenwert laden	
	tst temp								; Null ?				
	breq MFM_MUSTER_FOUND					; Voll-Treffer			
;-------------------------------------------------------------------------------
MFM_w2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN LOW	
	rjmp MFM_w2	
;-------------------------------------------------------------------------------
	rjmp MFM_s								; weiter suchen			
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
MFM_MUSTER_FOUND:
	clr temp8								; Byte							
	ldi temp9,8								; Byte-Counter					
;-------------------------------------------------------------------------------
MFM_s2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN LOW	
	rjmp MFM_s2
;-------------------------------------------------------------------------------
MFM_DATA:									; Schleife						
	in temp1,TCNT0							; Zeitstempel					
	OUT TCNT0,NULL							; Null							
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Umrechnung von Zeiten- in Zellenwerte											
	cpi temp1,(ZELLE1)						; Zellenwert-1	
	brlo MFM_Z1
	cpi temp1,(ZELLE2)						; Zellenwert-2	
	brlo  MFM_Z2
	rjmp MFM_Z3								; Zellenwert-3	
;-------------------------------------------------------------------------------
; DECODIERUNG																	
MFM_Z1:				; 1 Zelle: 	Schreibe Merkbit, Merke Merkbit										
	mov temp,temp4	; Merkbit=Merkbit				
	ROR temp		; C kullert raus				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
;-------------------------------------------------------------------------------
MFM_Z2:				; 2 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM_Z21		
;-------------------------------------------------------------------------------
MFM_Z20:			; Merkbit 0:Schreibe 0+1, Merke 1
	mov temp4,EINS	; Merkbit=1						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_Z2w	
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
;-------------------------------------------------------------------------------
MFM_Z2w:
	SEC 			; EINS (Set Carry)				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
;-------------------------------------------------------------------------------
MFM_Z21:			; Merkbit-1:Schreibe 0, Merke 0	
	mov temp4,NULL	; Merkbit=0						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
;-------------------------------------------------------------------------------
MFM_Z3:				; 3 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM_Z20	; Merkbit 1:Schreibe 0+1; Merke 1 (wie 2 Zellen)		
;-------------------------------------------------------------------------------
	mov temp4,NULL	; Merkbit 0:Schreibe 0+0; Merke 0
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_Z30w
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
;-------------------------------------------------------------------------------
MFM_Z30w:
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw XL,1		; ZHLER-1	  ******************
;-------------------------------------------------------------------------------
MFM_ex:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN HIGH
	rjmp MFM_ex
;-------------------------------------------------------------------------------
MFM_s3:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)		; Schleife, bis PIN LOW	
	rjmp MFM_s3	
;-------------------------------------------------------------------------------
	tst XL									; Anzahl Data Bytes		
	breq MFM_DATA_e
	rjmp MFM_DATA							; Schleife				
MFM_DATA_e:
	tst XH									; Anzahl Data Bytes		
	breq MFM_DATA_ENDE
	rjmp MFM_DATA							; Schleife				
MFM_DATA_ENDE:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MFM_CHECK:
	ldi YL,LOW (adr_DATA+2)					; DATA			
	ldi YH,HIGH(adr_DATA+2)
	ldi temp1,low (520)
	ldi temp2,high(520)
	ldi temp9,1
MFM_CHECK_s:
	LD temp,Y
	cp temp,temp9
	brne MFM_CHECK_ERROR
	add YL,temp1
	adc YH,temp2
	inc temp9
	cpi temp9,18+1
	brne MFM_CHECK_s
;-------------------------------------------------------------------------------
	ldi YL,LOW (adr_DATA+1)					; DATA			
	ldi YH,HIGH(adr_DATA+1)
	ldi temp1,low (520)
	ldi temp2,high(520)
	ldi temp9,1
	LD  temp3,Y
MFM_CHECK_s1:
	LD temp,Y
	cp temp,temp3
	brne MFM_CHECK_ERROR
	add YL,temp1
	adc YH,temp2
	inc temp9
	cpi temp9,18+1
	brne MFM_CHECK_s1
	ret
;-------------------------------------------------------------------------------
MFM_CHECK_ERROR:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus		
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MFM_ANZEIGE:
	call LCD_CLEAR
	ldi YL,LOW (adr_DATA)	; ERGEBNIS						
	ldi YH,HIGH(adr_DATA)
	call MFM_ANZEIGE_ZEILE
	call LCD_ZEILE2
	call MFM_ANZEIGE_ZEILE
	call LCD_ZEILE3
	call MFM_ANZEIGE_ZEILE
	call LCD_ZEILE4
	call MFM_ANZEIGE_ZEILE
	ret
;-------------------------------------------------------------------------------
MFM_ANZEIGE_ZEILE:
	ldi temp9,5
MFM_ANZEIGE_ZEILE_s:
	LD temp1,Y+
	call LCD_HEX_TEMP1
	call LCD_SPACE
	dec temp9
	brne MFM_ANZEIGE_ZEILE_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################










;			  0123456789 0123456789 0123456789									
; Bitmuster: "1111111232 3213232132 3211111112"									
;			 00h A1h A1h A1h FEh												
TABELLE_MFM_ID_SEKTOR:
.db 2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,1,1,2,0
;			  0123456789 0123456789 012345678									
; Bitmuster: "1111111232 3213232132 321111131"									
;			 00h A1h A1h A1h FBh												
TABELLE_MFM_ID_DATA:
.db 2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,3,1,0,0
