; ##############################################################################
; ##############################################################################
; ##############################################################################
; Messung Zeitstempel															
MFM1:	
	CLI									; INTERRUPTS sperren !!!	
	ldi XL,LOW (adr_DATA)				; DATA				
	ldi XH,HIGH(adr_DATA)
	clr temp1							; Zeitstempel		
;-------------------------------------------------------------------------------
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)	; ROT  aus			
	call FLOPPY_MOTOR_ON				; Motor on			
	rcall FLOPPY_WAIT_INDEX_HIGH		; Index				
	rcall FLOPPY_WAIT_INDEX_LOW			; Index				
;-------------------------------------------------------------------------------
MFM1_s1:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM1_s1
;-------------------------------------------------------------------------------
MFM1_s2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM1_s2
;-------------------------------------------------------------------------------
	OUT TCNT0,NULL						; Null					
;-------------------------------------------------------------------------------
MFM1_s3:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM1_s3
;-------------------------------------------------------------------------------
MFM1_s4:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM1_s4
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
MFM1_RUN:
	in temp1,TCNT0						; Zeitstempel	
	OUT TCNT0,NULL						; Null			
;-------------------------------------------------------------------------------
MFM1_s:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN HIGH		
	rjmp MFM1_s
;-------------------------------------------------------------------------------
; Umrechnung von Zeiten- in Zellenwerte											
	ldi temp2,1							; Zellenwert-1	
	cpi temp1,54
	brlo MFN1_w
	ldi temp2,2							; Zellenwert-2	
	cpi temp1,75
	brlo MFN1_w
	ldi temp2,3							; Zellenwert-3	
MFN1_w:
	ST X+,temp2							; Zellenwerte					
;	ST X+,temp1							; Zeitstempel (fr Testzwecke)	
;-------------------------------------------------------------------------------
MFM1_e:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN LOW	
	rjmp MFM1_e
;-------------------------------------------------------------------------------
	cpi XL,LOW (adr_SRAM_CHECK)			; Ende ?		
	brne MFM1_RUN
	cpi XH,HIGH(adr_SRAM_CHECK)			; Ende ?		
	brne MFM1_RUN
;-------------------------------------------------------------------------------
	call RS232_TX_SRAM  				;(fr Testzwecke)	
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; Initialisierung																
	ldi XL,LOW (adr_DATA)					; DATA			
	ldi XH,HIGH(adr_DATA)
	ldi YL,LOW (adr_DATA)					; ERGEBNIS		
	ldi YH,HIGH(adr_DATA)
;-------------------------------------------------------------------------------
; Sektor-A suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SEKTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SEKTOR*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
; Sektor-B suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SEKTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SEKTOR*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
; Sektor-C suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SEKTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SEKTOR*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM1_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM1_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN 
;-------------------------------------------------------------------------------
; Ergebnis im SRAM																
	call LCD_CLEAR					; LCD-clear	
	call TEXT_SPUR
	LDS temp1,(adr_DATA+5)
	call LCD_ZAHL2_temp1			; SPUR 		
	call LCD_SPACE

	call TEXT_HEAD
	LDS temp1,(adr_DATA+6)
	call LCD_ZAHL1_temp1			; HEAD		
	call LCD_SPACE

	call LCD_ZEILE2					; LCD-Zeile	
	call LCD_A
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*0)	; Sektor-A	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*0)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*0)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*0)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*0)	; DataBytes3
	call LCD_HEX_TEMP1

	call LCD_ZEILE3					; LCD-Zeile	
	call LCD_B
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*1)	; Sektor-B	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*1)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*1)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*1)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*1)	; DataBytes3
	call LCD_HEX_TEMP1

	call LCD_ZEILE4					; LCD-Zeile	
	call LCD_C
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*2)	; Sektor-C	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*2)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*2)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*2)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*2)	; DataBytes3
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
;	call RS232_TX_SRAM
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP:	X Start-Position														
;		Z (Tabelle)																
; OUT:	X Treffer-Position														
MFM1_FIND_XZ:
	WDR
	mov R0,ZL								; Z (Tabelle) sichern	
	mov R1,ZH
	mov R2,XL								; X Start-Position sichern	
	mov R3,XH
;-------------------------------------------------------------------------------
MFM1_FIND_RUN:
	mov ZL,R0								; Z (Tabelle) wieder herstellen		
	mov ZH,R1

	add R2,EINS								; X Start-Position + 1 				
	adc R3,NULL
	mov XL,R2
	mov XH,R3

	cpi XL,LOW (adr_SRAM_CHECK)				; berlauf	?	
	brne MFM1_FIND_NEXT
	cpi XH,HIGH(adr_SRAM_CHECK)
	brne MFM1_FIND_NEXT
	rjmp MFM1_FIND_ERROR						; Error			
;-------------------------------------------------------------------------------
MFM1_FIND_NEXT:
	LPM R4, Z+ 		  						; Tabellenwert laden	
	tst R4									; Null ?				
	breq MFM1_FIND_TREFFER					; Voll-Treffer			
	LD R5, X+								; X laden				
	cp R4,R5								; Vergleich 			
	breq MFM1_FIND_NEXT						; Treffer				
	rjmp MFM1_FIND_RUN						; no Treffer			
;-------------------------------------------------------------------------------
MFM1_FIND_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an		
	clr XL
	clr XH
	ret
;-------------------------------------------------------------------------------
MFM1_FIND_TREFFER:
	mov ZL,R0								; Z (Tabelle) wieder herstellen		
	mov ZH,R1
	clr R3									; length Tabelle
MFM1_FIND_s1:
	LPM R2, Z+ 		  						; Wert laden	
	tst R2									; Null ?		
	breq MFM1_FIND_ENDE
	inc R3									; length Tabelle
	rjmp MFM1_FIND_s1
;-------------------------------------------------------------------------------
; Ergebnis X																	
MFM1_FIND_ENDE:
	sub XL,R3								; length Tabelle
	sbc XH,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; X (DATA)																		
; Y (Ergebnis)																	
; Z (Anzahl BYTES)																
; 																				
MFM1_DECODIERUNG_XYZ:
	tst XL
	brne MFM1_DECODIERUNG_RUN
	tst XH
	brne MFM1_DECODIERUNG_RUN
	ret
;-------------------------------------------------------------------------------
MFM1_DECODIERUNG_RUN:
	mov temp4,NULL	; Merkbit=0						
	clr temp8		; Byte							
	ldi temp9,8		; Byte-Counter					
;-------------------------------------------------------------------------------
MFM1_DECODIERUNG_s:
	LD temp,X+		; laden							
	cpi temp,1		; Zelle=1						
	breq MFM1_Z1
	cpi temp,2		; Zelle=2						
	breq MFM1_Z2
	rjmp MFM1_Z3	; Zelle=3						
; ##############################################################################
MFM1_Z1:			; 1 Zelle: 	Schreibe Merkbit, Merke Merkbit										
	mov temp,temp4	; Merkbit=Merkbit				
	ROR temp		; C kullert raus				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_ex	; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM1_ex	; Exit							
; ##############################################################################
MFM1_Z2:			; 2 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM1_Z21		
;-------------------------------------------------------------------------------
MFM1_Z20:			; Merkbit 0:Schreibe 0+1, Merke 1
	mov temp4,EINS	; Merkbit=1						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_Z2w	
	ST Y+,temp8		; Byte write************		
	ldi temp9,8		; Byte-Counter					
	sbiw ZL,1		; ZHLER-1						
;-------------------------------------------------------------------------------
MFM1_Z2w:
	SEC 			; EINS (Set Carry)				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_ex	; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM1_ex	; Exit							
;-------------------------------------------------------------------------------
MFM1_Z21:			; Merkbit-1:Schreibe 0, Merke 0	
	mov temp4,NULL	; Merkbit=0						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_ex	; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM1_ex	; Exit							
; ##############################################################################
MFM1_Z3:			; 3 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM1_Z20	; Merkbit 1:Schreibe 0+1; Merke 1 (wie 2 Zellen)		
;-------------------------------------------------------------------------------
	mov temp4,NULL	; Merkbit 0:Schreibe 0+0; Merke 0
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_Z30w
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
MFM1_Z30w:
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM1_ex	; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
;-------------------------------------------------------------------------------
MFM1_ex:
	tst ZL
	brne MFM1_DECODIERUNG_s
	tst ZH
	brne MFM1_DECODIERUNG_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################










;			  0123456789 0123456789 0123456789									
; Bitmuster: "1111111232 3213232132 3211111112"									
;			 00h A1h A1h A1h FEh												
TABELLE_ID_SEKTOR:
.db 1,1,1,1,1,1,1,2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,1,1,2,0,0

;			  0123456789 0123456789 012345678									
; Bitmuster: "1111111232 3213232132 321111131"									
;			 00h A1h A1h A1h FBh												
TABELLE_ID_DATA:
.db 1,1,1,1,1,1,1,2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,3,1,0,0,0












