;												
; Floppy-DECODER an ATmega1284P					
; eine komplette Spur einlesen mit 18 Sektoren	
; mit SD-CARD + RS232 (5V)						
;												
; Bernhard.Erfurt@gmx.de						
; 10.2018										
;												
; blinkende LED: schwerer Error					

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT					= 22000000	; 22 MHz
; Timerwerte									
.equ TIM3WERT=65535-34375 				; 22.000.000:64=343.750 :10 =34.375
; Motor off										
.equ SLEEPWERT				= 60		; in s	
; Error-Codes									
.equ ERROR_CODE_SD_INI				= 0xE0
.equ ERROR_CODE_SD_BLOCKLAENGE		= 0xE1
.equ ERROR_CODE_SD_READ				= 0xEA
.equ ERROR_CODE_SD_READ_MULTIPLE	= 0xEB
.equ ERROR_CODE_SD_WRITE			= 0xEC
.equ ERROR_CODE_SD_WRITE_MULTIPLE	= 0xED
; REGISTER										
.def SEKTOR0	= R8
.def SEKTOR1	= R9
.def SEKTOR2	= R10
.def SEKTOR3	= R11

.def ERROR		= R12
.def NULL 		= R13
.def EINS 		= R14
.def VOLL 		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25
; RS232											
.equ RS232_PIN_NR			= 6
.equ RS232_DDR				= DDRD
.equ RS232_PORT				= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR		= 2
.equ LED_GRUEN_DDR			= DDRB
.equ LED_GRUEN_PORT			= PORTB
; LED-ROT										
.equ LED_ROT_PIN_NR			= 3
.equ LED_ROT_DDR			= DDRB
.equ LED_ROT_PORT			= PORTB
; SPI-CS										
.equ SPI_CS_PIN_NR			= 4
.equ SPI_CS_DDR				= DDRB
.equ SPI_CS_PORT			= PORTB
; SPI-MOSI										
.equ SPI_MOSI_PIN_NR		= 5
.equ SPI_MOSI_DDR			= DDRB
.equ SPI_MOSI_PORT			= PORTB
; SPI-MISO										
.equ SPI_MISO_PIN_NR		= 6
.equ SPI_MISO_DDR			= DDRB
.equ SPI_MISO_PORT			= PORTB
; SPI-SCK										
.equ SPI_SCK_PIN_NR			= 7
.equ SPI_SCK_DDR			= DDRB
.equ SPI_SCK_PORT			= PORTB






; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)					
.equ adr_DATEN						=SRAM_START+0	; 0x0060 START Adresse 		

.equ adr_ss_VT						=SRAM_START+1		
.equ adr_ss							=SRAM_START+2		; Sekunden					
.equ adr_mm							=SRAM_START+3		; Minuten					
.equ adr_hh							=SRAM_START+4		; Stunden					

.equ adr_MENUE						=SRAM_START+5
.equ adr_TASTE						=SRAM_START+6		

.equ adr_FLOPPY_MOTOR_ON			=SRAM_START+10		; 0/1						
.equ adr_FLOPPY_SLEEP				=SRAM_START+11		; SLEEP Timer 0=Motor off	
.equ adr_FLOPPY_SELECT				=SRAM_START+12		; 0=A 1=B					
.equ adr_FLOPPY_HEAD				=SRAM_START+13		; 0=0 1=1					
.equ adr_FLOPPY_SPUR				=SRAM_START+14		; 1...18					

.equ adr_TWI_BEREICH_READ			=SRAM_START+40		; BEREICH fr Master TWI/I2C	

.equ adr_SD_SEKTOR_MAX0				=SRAM_START+200		; Sekector max		
.equ adr_SD_SEKTOR_MAX1				=SRAM_START+201		; Sekector max		
.equ adr_SD_SEKTOR_MAX2				=SRAM_START+202		; Sekector max		
.equ adr_SD_SEKTOR_MAX3				=SRAM_START+203		; Sekector max		

.equ adr_SD_CAPACITY_MB0			=SRAM_START+204		; Capacity in MB	
.equ adr_SD_CAPACITY_MB1			=SRAM_START+205		; Capacity in MB	
.equ adr_SD_CAPACITY_MB2			=SRAM_START+206		; Capacity in MB	
.equ adr_SD_CAPACITY_MB3			=SRAM_START+207		; Capacity in MB	

.equ adr_SD_SDHC_AKTIV				= SRAM_START+210	; 0=SDSC 1=SDHC		
.equ adr_SD_CSD_READ_BL_LEN			= SRAM_START+211 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0			= SRAM_START+212	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1			= SRAM_START+213	; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_MULT			= SRAM_START+214 	; Register CSD =>C_SIZE_MULT	
.equ adr_SD_CSD_MULT_L				= SRAM_START+215
.equ adr_SD_CSD_MULT_H				= SRAM_START+216

.equ adr_DATA						=SRAM_START+6300	; DATA FLOPPY / SD				

.equ adr_SRAM_CHECK					=SRAM_START+16300	; SRAM CHECK muss immer "S" sein	



.cseg							;Beginn eines Code-Segmentes
.org 0							;Startadresse=0				
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 rjmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA			
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF 	; Timer1 Overflow		
.org 0x0020 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPA ; Timer0 CompareA			
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;TIM0_OVF 	; Timer0 Overflow				
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp TIM3_OVF 	; Timer3 Overflow					
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 												
INTERRUPT_ERROR:
	call LCD_CLEAR
	call LCD_I
	call LCD_N
	call LCD_T
	call LCD_ZEILE2
	call TEXT_ERROR
INTERRUPT_ERROR_s:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
	call wait_100ms
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	call wait_100ms
	rjmp INTERRUPT_ERROR_s
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)			; STACK initialisieren		
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	call SRAM_CLEAR					; SRAM_CLEAR			
	call STARTWERTE					; Startwerte			
	call PORT_CLEAR					; Ports CLER			
	call LED_INITIALISIERUNG		; LED					
	call WDR_INITIALISIERUNG		; WDR					
	call LCD_INITIALISIERUNG		; LCD					
	call LCD_ANZEIGE_BEGRUESSUNG	; LCD					
	call RS232_INITIALISIERUNG		; RS232					
	call TIMER0_INITIALISIERUNG		; Timer0 MFM			
	call TIMER3_INITIALISIERUNG		; Uhr					
	call SPI_INITIALISIERUNG		; SPI					
	call TWI_INITIALISIERUNG		; TWI					
	call FLOPPY_INITIALISIERUNG		; Floppy				
	call PROGRAMM_CHECK				; Check					
;-------------------------------------------------------------------------------
	SEI								; Interrupts enable		
	call LCD_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR								; Watch-Dog-RESET	
	call TASTEN_ABFRAGE
	call MENUE
	call TASTEN_WAIT	
	call PROGRAMM_CHECK				; Check					
	call FLOPPY_SLEEP
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; TIMER				
.include "MFM.asm"				; MFM				
.include "MFM1.asm"				; MFM1				
.include "MFM4.asm"				; MFM4				
.include "SONSTIGES.asm"		; sonstiges			
.include "FLOPPY.asm"			; FDD				
.include "SD.asm"				; SD				
.include "SPI.asm"				; SPI				
.include "LCD.asm"				; LCD				
.include "LCD_ANZEIGE.asm"		; LCD				
.include "LCD_TEXTE.asm"		; LCD				
.include "TASTEN.asm"			; Tasten			
.include "WAIT.asm"				; wait				
.include "TWI.asm"				; TWI				
.include "MENUE.asm"			; Menue				
.include "RS232.asm"			; RS232				
; LCD							
TEXT_LCD_BEGRUESSUNG_1:
.db "3.5' Floppy",0
TEXT_LCD_BEGRUESSUNG_2:
.db "ATmega1284p",0
TEXT_LCD_BEGRUESSUNG_3:
.db "22MHz LCD 16x2 ",0
TEXT_LCD_BEGRUESSUNG_4:
.db "10/2018",0
